regina::Property< T, Storage > Class Template Reference
Miscellaneous Utilities

Stores a calculable property of an object. More...

`#include <utilities/property.h>`

Inheritance diagram for regina::Property< T, Storage >:

## Public Types

typedef Storage< T >::InitType | InitType
| The type by which new values for the underlying property are passed. More...
typedef Storage< T >::QueryType | QueryType
| The type by which the property value is returned to the user. More...

## Public Member Functions

| Property ()
| Constructor. More...
bool | known () const
| Returns whether or not this property is currently marked as known. More...
QueryType | value () const
| Returns the current value of this property. More...
void | clear ()
| Marks this property as unknown. More...
QueryType | operator= (InitType newValue)
| Assigns a new value to this property. More...
const Property< T, Storage > & | operator= (const Property< T, Storage > &newValue)
| Copies the given property into this property. More...
void | swap (Property< T, Storage > &other)
| Swaps this with the given property. More...

## Detailed Description

### template<typename T, template< typename Stored > class Storage = StoreValue>
class regina::Property< T, Storage >

Stores a calculable property of an object.

The property may be marked as known or unknown, and its value may be set or retrieved.

The template parameter Storage specifies how the property will be internally stored. Storage options range from simple storage by value (see class StoreValue) to more intelligent storage options that include memory management of pointers (see class StoreManagedPtr).

See also
  StoreValue
  StoreConstPtr
  StoreManagedPtr

Python:
  Not present.

## Member Typedef Documentation

## InitType

template<typename T, template< typename Stored > class Storage = StoreValue>

typedef Storage<T>::InitType regina::Property< T, Storage >::InitType

The type by which new values for the underlying property are passed.

## QueryType

template<typename T, template< typename Stored > class Storage = StoreValue>

typedef Storage<T>::QueryType regina::Property< T, Storage >::QueryType

The type by which the property value is returned to the user.

## Constructor & Destructor Documentation

## Property()

template<typename T, template< typename Stored > class Storage = StoreValue>

regina::Property< T, Storage >::Property | ( |  | ) |

inline

Constructor.

This property is initially marked as unknown.

## Member Function Documentation

## clear()

template<typename T, template< typename Stored > class Storage = StoreValue>

void regina::Property< T, Storage >::clear | ( |  | ) |

inline

Marks this property as unknown.

## known()

template<typename T, template< typename Stored > class Storage = StoreValue>

bool regina::Property< T, Storage >::known | ( |  | ) | const

inline

Returns whether or not this property is currently marked as known.

Returns
  whether this property is marked as known.

## operator=() [1/2]

template<typename T, template< typename Stored > class Storage = StoreValue>

QueryType regina::Property< T, Storage >::operator= | ( | InitType | newValue | ) |

inline

Assigns a new value to this property.

The property will be marked as known.

Parameters

  newValue | the new value to assign to this property.

Returns
  the new value of this property.

## operator=() [2/2]

template<typename T, template< typename Stored > class Storage = StoreValue>

const Property<T, Storage>& regina::Property< T, Storage >::operator= | ( | const Property< T, Storage > & | newValue | ) |

inline

Copies the given property into this property.

If the given property is marked as known, its value will be copied and this property will also be marked as known. Otherwise this property will be marked as unknown.

Parameters

  newValue | the property to copy into this property.

Returns
  a reference to this property.

## swap()

template<typename T, template< typename Stored > class Storage = StoreValue>

void regina::Property< T, Storage >::swap | ( | Property< T, Storage > & | other | ) |

inline

Swaps this with the given property.

Both the known status and the values (if known) will swapped in the most efficient manner that the compiler is aware of.

Parameters

  other | the property to swap with this.

## value()

template<typename T, template< typename Stored > class Storage = StoreValue>

QueryType regina::Property< T, Storage >::value | ( |  | ) | const

inline

Returns the current value of this property.

If this property is marked as unknown then the results are undefined.

Precondition
  This property is currently marked as known.

Returns
  the current value of this property.

The documentation for this class was generated from the following file:

- utilities/property.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).